<?php


class Payzen
{
    protected $boutique_id;
    protected $mode;
    protected $certif;
    protected $urlPlatForm;
    protected $urlNotify;
    protected $urlReturn;
    protected $urlCancel;
    protected $urlError;
    protected $btn;
    protected $autovalide;
    protected $nameboutique;
    protected $urlboutique;
    protected $return_auto;

    public function __construct($config)
    {
        $this->boutique_id = $config['payzen']['boutique_id'];
        $this->mode = $config['payzen']['mode'];
        $this->certif = $config['payzen']['certif'];
        $this->urlPlatForm = $config['payzen']['urlPlatForm'];
        $this->urlNotify = $config['payzen']['urlNotify'];
        $this->urlReturn = $config['payzen']['urlReturn'];
        $this->urlCancel = $config['payzen']['urlCancel'];
        $this->urlError = $config['payzen']['urlError'];
        $this->btn = $config['payzen']['btn'];
        $this->autovalide = $config['payzen']['autovalide'];
        if(!empty($config['payzen']['nameboutique'])) {
            $this->nameboutique = $config['payzen']['nameboutique'];
        }
        if(!empty($config['payzen']['urlboutique'])) {
            $this->urlboutique = $config['payzen']['urlboutique'];
        }
        if(!empty($config['payzen']['return_auto'])) {
            $this->return_auto = $config['payzen']['return_auto'];
        }else{
            $this->return_auto = true;
        }

    }




    /**
     * @param Tpe $tpe
     * @param $amount
     *
     * @return array
     */
    public function bootRequest(Tpe $tpe, $amount)
    {
        // generation du numero de transaction
        date_default_timezone_set("UTC");
        $ts = time();
        $trans_date = date("YmdHis", $ts);
        $trans_id = date("His", $ts);

        // parametres bancaire
        $params = array();

        $params['vads_site_id'] = $this->boutique_id;
        $params['vads_ctx_mode'] = $this->mode;
        $params['vads_trans_id'] = str_pad($tpe->tpe_reference_id,6,'0',STR_PAD_LEFT);

        $params['vads_trans_date'] = $trans_date;
        $params['vads_cust_id'] = $tpe->getClient()->client_id;
        $params['vads_cust_first_name'] = $tpe->getClient()->prenom_nom;
        $params['vads_cust_last_name'] = $tpe->getClient()->client_nom;
        $params['vads_cust_title'] = $tpe->getClient()->civilite_nom_nom;
        $params['vads_cust_email'] = $tpe->getClient()->client_email;

        $params['vads_currency'] = '978';
        $params['vads_action_mode'] = 'INTERACTIVE';
        $params['vads_page_action'] = 'PAYMENT';
        $params['vads_version'] = 'V2';
        $params['vads_return_mode'] = 'POST';

        $params['vads_capture_delay'] = 0;
        $params['vads_validation_mode'] = '1';

        // pour activer le retour auto sur le site
        if ($this->return_auto) {
            $redirectMessage = 'Vous allez être redirigé vers votre site marchand';
            $params['vads_redirect_error_message'] = $redirectMessage;
            $params['vads_redirect_error_timeout'] = 5;
            $params['vads_redirect_success_message'] = $redirectMessage;
            $params['vads_redirect_success_timeout'] = 5;
        }

        $params['vads_url_check'] = $this->urlNotify;
        $params['vads_url_return'] = $this->urlReturn;
        $params['vads_url_success"'] = $this->urlReturn;
        $params['vads_url_cancel'] = $this->urlCancel;
        $params['vads_url_refused'] = $this->urlError;
        $params['vads_url_error'] = $this->urlError;

        list($arrTpe)=$tpe->get(array('tpe_reference_id' =>$tpe->tpe_reference_id));
        $panier =unserialize($arrTpe['tpe_reference_session']);
        if(!empty($panier->getAddressShipping())) {
            $adrLivraison=$panier->getAddressShipping()->toArray();

            if(!empty($adrLivraison['adresse_prenom'])) {
                $params['vads_ship_to_first_name'] = $this->noCartereSpec($adrLivraison['adresse_prenom']);
            }
            if(!empty($adrLivraison['adresse_nom'])) {
                $params['vads_ship_to_last_name'] = $this->noCartereSpec($adrLivraison['adresse_nom']);
            }
            if(!empty($adrLivraison['adresse_telephone'])) {
                $params['vads_ship_to_phone_num'] = $this->noCartereSpec($adrLivraison['adresse_telephone']);
            }
            if(!empty($adrLivraison['adresse_rue'])) {
                $params['vads_ship_to_street'] = $this->noCartereSpec($adrLivraison['adresse_rue']);
            }
            if(!empty($adrLivraison['adresse_rue2'])) {
                $params['vads_ship_to_street2'] = $this->noCartereSpec($adrLivraison['adresse_rue2']);
            }
            if(!empty($adrLivraison['adresse_cp'])) {
                $params['vads_ship_to_zip'] = $this->noCartereSpec($adrLivraison['adresse_cp']);
            }
            if(!empty($adrLivraison['adresse_ville'])) {
                $params['vads_ship_to_city'] = $this->noCartereSpec($adrLivraison['adresse_ville']);
            }
            if(!empty($adrLivraison['pays_iso_code_2'])) {
                $params['vads_ship_to_country'] = $adrLivraison['pays_iso_code_2'];
            }

        }



        return $params;
    }

    /**
     * @param int $idReference
     * @param float $amount
     * @return mixed
     */
    public function request(Tpe $tpe, $amount, $params = array())
    {

        $params = array_merge($this->bootRequest($tpe, $amount), $params);
        $params['vads_payment_config'] = 'SINGLE';
        $params['vads_amount'] = round($amount * 100);


        if(!empty($this->nameboutique)) {
            $params['vads_shop_name'] = $this->nameboutique;
        }
        if(!empty($this->urlboutique)) {
            $params['vads_shop_url'] = $this->urlboutique;
        }


        $params['signature'] = $this->sign($params);

        return $this->generateForm($params);

    }

    /**
     * @param Panier $panier
     * @param float $amount
     * @param array $params
     * @return mixed
     */
    public function requestFromPanier(Panier $panier, $amount, $params = array())
    {
        $params = array_merge($this->bootRequest(new Tpe($panier->getReference()), $amount), $params);
        $params['vads_payment_config'] = 'SINGLE';
        $params['vads_amount'] = round($amount * 100);


        if(!empty($this->nameboutique)) {
            $params['vads_shop_name'] = $this->nameboutique;
        }
        if(!empty($this->urlboutique)) {
            $params['vads_shop_url'] = $this->urlboutique;
        }

        $params['signature'] = $this->sign($params);

        return $this->generateForm($params);
    }


    /**
     * @param int $idReference
     * @param float $amount
     * @param int $nb_prelevement
     * @param int $nb_jour
     * @return mixed
     */
    public function request_multi(Tpe $tpe, $amount, $params = array(),$nb_prelevement, $nb_jour)
    {

        $params = array_merge($this->bootRequest($tpe, $amount), $params);

        $amouttot = round($amount,2) * 100;

        $amountmois = ceil($amouttot / $nb_prelevement);

        $params['vads_amount'] = $amouttot;
        $params['vads_payment_config'] = 'MULTI:first='.$amountmois.';count='.$nb_prelevement.';period='.$nb_jour;

        if(!empty($this->nameboutique)) {
            $params['vads_shop_name'] = $this->nameboutique;
        }
        if(!empty($this->urlboutique)) {
            $params['vads_shop_url'] = $this->urlboutique;
        }

        $params['signature'] = $this->sign($params);

        return $this->generateForm($params);

    }

    /**
     * Utility function, builds and returns the signature string of the data
     *  being transmitted to the PayZen plat-form
     *
     * @param $vads_form array, array of data being signed
     *
     * @return String, the signature
     */
    public function sign(Array $vads_form) {
        // Choice between TEST and PRODUCTION certificates
        $cert = $this->certif;
        ksort($vads_form);           // VADS values sorted by name, ascending order
        return sha1(                 // SHA1 encryption of ...
            implode('+', $vads_form)    // ... VADS array values joined with '+' ...
            . "+$cert"                  // ... concatenated with '+' and the certificate.
        );
    }

    /**
     * @param array
     * @return string
     */
    function generateForm($params) {
        $out ='<form style="display:none;" action="'.$this->urlPlatForm.'" method="POST" enctype="UTF-8" accept-charset="multipart/form-data" class="formpayzen" id="formpayzen">';

        foreach($params as $key => $val) {
            $out .= '<input type="hidden" name="'.$key.'" value="'.$val.'" />';
        }
        $out .= '<input name="Valider" value="Valider" type="image" src="'.$this->btn.'" alt="Valider" id="valide_cb"/>'."\n";

        $out .= '</form>';

        if($this->autovalide) {
            $out.='<script type="text/javascript">jQuery(document).ready(function(){jQuery(\'#formpayzen\').submit()});</script>';
        }

        return $out;

    }

    /**
     * @param array $request
     * @return mixed
     */
    public function response($request)
    {
        if(empty($request) && !empty($_POST)) {
            $request = $_POST;
        }
        if(empty($request) && !empty($_GET)) {
            $request = $_GET;
        }
        if(empty($request)) {
            return false;
        }

        if(empty($request['vads_trans_id'])) {
            return false;
        }
        $order_id = $request['vads_trans_id'];

        $tpe = new Tpe;
        if(empty($request['vads_trans_status']) || ($request['vads_trans_status'] != 'AUTHORISED' && $request['vads_trans_status'] != 'AUTHORISED_TO_VALIDATE')) {
            $tpe->paiementKO($order_id, $request);
            return false;
        }

        if(!isset($request['vads_auth_result']) || $request['vads_auth_result'] != '00') {
            $tpe->paiementKO($order_id, $request);
            return false;
        }

        $params = array();
        foreach($request as $key => $val) {
            if(substr($key,0,5) == 'vads_') {
                $params[$key] = $val;
            }
        }
        $signature = $this->sign($params);

        if(isset($request['signature']) && ($signature == $request['signature'])) {
            $tpe->paiementOK($order_id, $request);
            return false;
        } else {
            $tpe->paiementKO($order_id, $request);
            return false;
        }
    }

    public function noCartereSpec($text) {


        $text = trim(mb_strtolower($text));

        $table = array(
            'Š' => 'S', 'š' => 's', 'Đ' => 'D', 'đ' => 'd', 'Ž' => 'Z', 'ž' => 'z', 'Č' => 'C', 'č' => 'c', 'Ć' => 'C', 'ć' => 'c',
            'À' => 'A', 'Á' => 'A', 'Â' => 'A', 'Ã' => 'A', 'Ä' => 'A', 'Å' => 'A', 'Æ' => 'A', 'Ç' => 'C', 'È' => 'E', 'É' => 'E',
            'Ê' => 'E', 'Ë' => 'E', 'Ì' => 'I', 'Í' => 'I', 'Î' => 'I', 'Ï' => 'I', 'Ñ' => 'N', 'Ò' => 'O', 'Ó' => 'O', 'Ô' => 'O',
            'Õ' => 'O', 'Ö' => 'O', 'Ø' => 'O', 'Ù' => 'U', 'Ú' => 'U', 'Û' => 'U', 'Ü' => 'U', 'Ý' => 'Y', 'Þ' => 'B', 'ß' => 'Ss',
            'à' => 'a', 'á' => 'a', 'â' => 'a', 'ã' => 'a', 'ä' => 'a', 'å' => 'a', 'æ' => 'a', 'ç' => 'c', 'è' => 'e', 'é' => 'e',
            'ê' => 'e', 'ë' => 'e', 'ì' => 'i', 'í' => 'i', 'î' => 'i', 'ï' => 'i', 'ð' => 'o', 'ñ' => 'n', 'ò' => 'o', 'ó' => 'o',
            'ô' => 'o', 'õ' => 'o', 'ö' => 'o', 'ø' => 'o', 'ù' => 'u', 'ú' => 'u', 'û' => 'u', 'ý' => 'y', 'þ' => 'b',
            'ÿ' => 'y', 'Ŕ' => 'R', 'ŕ' => 'r', ' - ' => '-', '&' => 'et', "'" => ' '
        );

        $text = strtr($text, $table);

        $text = preg_replace('/[^a-z0-9-]/', '', $text);

        return $text;
    }


}